import os
import sys
import unittest

from common import gobject, gtk_git

class APITest(unittest.TestCase):
    def testKeysyms(self):
        self.failUnless('Escape' in dir(gtk_git.keysyms))
        self.failUnless(hasattr(gtk_git.keysyms, 'Escape'))
        self.assertEqual(gtk_git.keysyms.Escape, 0xFF1B)

    def testWindow(self):
        self.failUnless(hasattr(gtk, 'Window'))
        self.failUnless(issubclass(gtk_git.Window, gobject.GObject))
        self.failUnless(issubclass(gtk_git.Window, gtk_git.Object))
        self.failUnless(issubclass(gtk_git.Window, gtk_git.Widget))
        self.failUnless(issubclass(gtk_git.Window, gtk_git.Container))
        self.failUnless(issubclass(gtk_git.Window, gtk_git.Bin))
        w = gtk_git.Window()
        self.failUnless(isinstance(w, gtk_git.Window))

    def testAccelLabel(self):
        ra = gtk_git.RadioMenuItem(None, 'label')
        self.failUnless(hasattr(ra.get_child(), 'get_text'))
        self.assertEqual(ra.get_child().get_text(), 'label')

    def testGlade(self):
        self.failUnless(hasattr(gtk_git.glade, 'XML'))
        self.failUnless(issubclass(gtk_git.glade.XML, gobject.GObject))

    def testReload(self):
        # test for #349026
        del sys.modules['gtk_git']
        import gtk_git
        reload(gtk_git)
