# -*- Mode: Python -*-

import unittest

import gtk_git


class Tests(unittest.TestCase):

    def test_equal(self):
        self.assertEqual(gtk_git.gdk.Rectangle(0, 0, 1, 1), gtk_git.gdk.Rectangle(0, 0, 1, 1))

    def test_not_equal(self):
        self.assertNotEqual(gtk_git.gdk.Rectangle(1, 0, 10, 10), gtk_git.gdk.Rectangle(0, 0, 10, 10))
        self.assertNotEqual(gtk_git.gdk.Rectangle(0, 1, 10, 10), gtk_git.gdk.Rectangle(0, 0, 10, 10))
        self.assertNotEqual(gtk_git.gdk.Rectangle(0, 0, 11, 10), gtk_git.gdk.Rectangle(0, 0, 10, 10))
        self.assertNotEqual(gtk_git.gdk.Rectangle(0, 0, 10, 11), gtk_git.gdk.Rectangle(0, 0, 10, 10))

    def test_non_hashable(self):
        self.assertRaises(TypeError, lambda: hash(gtk_git.gdk.Rectangle()))

        def dict_key():
            {} [gtk_git.gdk.Rectangle()] = 'must raise'
        self.assertRaises(TypeError, dict_key)

    def test_repr(self):
        for rectangle in self._test_rectangle_list():
            self.assertEqual(rectangle, eval(repr(rectangle)))

    def _test_rectangle_list(self):
        return [gtk_git.gdk.Rectangle(),
                gtk_git.gdk.Rectangle(0, 0, 100, 100),
                gtk_git.gdk.Rectangle(-10, 10, 30, 50),
                gtk_git.gdk.Rectangle(-100, -100, 20, 25),
                gtk_git.gdk.Rectangle(0, 0, 0, 20),
                gtk_git.gdk.Rectangle(1, 1, 20, 0)]


if __name__ == '__main__':
    unittest.main()
